import { ACommonList } from './list.abstract';
import { listOf } from './list.functions';
export class EntityList extends ACommonList {
    constructor(items) {
        super(items);
    }
    create(list) {
        return new EntityList(list);
    }
    createSimpleList() {
        return listOf();
    }
    containsAny(item) {
        if (!item) {
            return false;
        }
        for (const entity of this) {
            if (entity.hashCode() === item.hashCode()) {
                return true;
            }
        }
        return false;
    }
    containsNone(item) {
        if (!item) {
            return false;
        }
        for (const entity of this) {
            if (entity.hashCode() === item.hashCode()) {
                return false;
            }
        }
        return true;
    }
    indexOf(searchElement, fromIndex = 0) {
        for (let i = fromIndex; i < this.size(); i++) {
            if (this[i].hashCode() === searchElement.hashCode()) {
                return i;
            }
        }
        return -1;
    }
}
//# sourceMappingURL=entity-list.js.map