export const s_imploder = (source) => {
    return ImploderBuilder.get(source);
};
export class ImploderBuilder {
    static get(source) {
        return new ImploderBuilder().source(source);
    }
    source(source) {
        this._source = source;
        return this;
    }
    mappedSource(source, mapFn) {
        if (mapFn && source) {
            this._source = source.map(mapFn);
        }
        return this;
    }
    maxLength(maxLength) {
        this._maxLength = maxLength;
        return this;
    }
    offset(offset) {
        this._offset = offset;
        return this;
    }
    separator(separator) {
        this._separator = separator;
        return this;
    }
    suffix(suffix) {
        this._suffix = suffix;
        return this;
    }
    build() {
        if (!this._source) {
            return '';
        }
        let source = this._source;
        if (this._offset) {
            source = source.slice(this._offset, source.length);
        }
        const toReturn = source.join(this._separator ?? '');
        if (this._maxLength && toReturn.length > this._maxLength) {
            return `${toReturn.slice(0, this._maxLength)}${this._suffix ?? ''}`;
        }
        return toReturn;
    }
}
//# sourceMappingURL=imploder.js.map